;- Title: Webcam viewer
;- Created by Easi2search INC
;- Email: webmaster@easi2search.com
;- Url: www.easi2search.com

;-EaSiScRiPt: 2.8+ Onli

on 1:load:/scl
on 1:start:/scl

alias scl { 
  /echo -s ***  WebCam Viewer Script Loaded ***
  set %scl.script webcam.mrc
  set %scl.dir $script(%scl.script)
  set %scl.numtok $numtok(%scl.dir,92)
  set %scl.tok 1- $+ $calc( %scl.numtok - 1)
  set %scl.gettok $gettok(%scl.dir,%scl.tok,92)
  set %mrc.folder %scl.gettok $+ \
  /unset %scl.*
}

alias wurl { 
  if ($1 == $null) goto error | goto set.url
  :set.url
  /set %camfile.url $1
  /set %camfile.host $gettok(%camfile.url,2,47)
  if ($2 == 1) goto host-file | goto file
  :file
  /set %camfile.numtok $numtok(%cam.url,47)
  /set %get 3- $+ %numtok
  /set %camfile.file $chr(47) $+ $gettok(%camfile.url,%get,47)
  goto display
  :host-file
  set %camfile.file %camfile.url
  :display  
  /echo -s -
  /echo -s Receiving Wbc Infomation from: %camfile.host CamFile: %camfile.file
  if (( $count(%camfile.url,/) > 2) && ( $count(%camfile.url,http) == 1) && ( $count(%camfile.url,.jpg) == 1)) goto webcam | goto error.1
  goto end
  :error
  /echo -s no url !
  goto end
  :error.1
  /echo -s ERROR: you did not correctly enter the right infomation!
  goto end
  :webcam
  /webcam 
  :end
}

alias webcam {
  /echo -s -
  /echo -s  Connecting . . . 
  .remove cam.jpg
  set %cam.ctime $ctime
  /sockopen webcam $+ $r(10000,9999) $+ $rnd(a,z) %camfile.host 80
}


on 1:sockopen:webcam*:{

  if ($sockerr) {
    //echo -
    echo 4 *** Error connecting to WebCam site
    /echo -s -
    halt
  }

  /fetch
}


on 1:sockread:webcam*:{

  :binary
  sockread -f &webcam
  /set %blen $bvar(&webcam,0)
  /set %bfind $bfind(&webcam,0,13 10 13 10)
  ;/echo Debug: %bfind > %bfw > %blen
  if (%blen == 0) goto miss.1 | goto dis.1
  :dis.1
  /echo -s Receiving %blen Bytes
  :miss.1
  if ($sockbr) {
    :bwr_check
    if (%bfw == yes) goto write | goto bfind
    :bfind
    if (%bfind > 0) goto bwr_wr | goto binary
    :bwr_wr
    ;/echo -s Debug: bcopy
    /set %brw.cal $calc(%bfind + 4)
    /bcopy -c &webcam 1 &webcam %brw.cal -1
    set %bfw yes
    :write 
    ;/echo -s - $bvar(&webcam,1-500).text
    bwrite cam.jpg -1 &webcam cam.jpg
    goto binary
  }
}

on 1:sockclose:webcam*:{
  :ctime_check
  %pt = $ctime - %cam.ctime
  /echo -s Receiving Webcam Finished,  Duration: $duration(%pt)
  /echo -s - 
  set %bfw no
  /showcam cam.jpg
  /unset %blen 
  /unset %bfind 
  /unset %brw.cal 
  /unset %bfw 
}

alias fetch {
  /sockwrite -n webcam* GET %camfile.file HTTP/1.0
  /sockwrite -n webcam* Accept: */*
  /sockwrite -n webcam* Accept-Language: en-gb
  /sockwrite -n webcam* Pragma: no-cache
  /sockwrite -n webcam* User-Agent: Mozilla/4.0(compatible; MSIE 5.5; Windows 98)
  /sockwrite -n webcam* Host: %camfile.host
  /sockwrite -n webcam* Proxy-Connection: Keep-Alive
  /sockwrite -n webcam*
}

;- base code

alias showcam {
  set %pic.webcam $1-
  set %pic.h $pic(%pic.webcam).height
  set %pic.w $pic(%pic.webcam).width
  set %pic.height $calc($pic(%pic.webcam).height + 30 )
  set %pic.width $calc($pic(%pic.webcam).width + 30)
  set %pic.size $pic(%pic.webcam).size
  set -u30 %cus.window @Webcam- $+ %camfile.url
  if ((%pic.h == 0) && (%pic.w == 0)) goto error | goto cont.1
  :cont.1
  if ( $window(%cus.window).state == $null) goto create-window | goto view-webcam
  :create-window
  /window -adok0 @Webcam- $+ %camfile.url 10 10 %pic.width %pic.height
  :view-webcam
  /background -x @Webcam- $+ %camfile.url
  /background -c @Webcam- $+ %camfile.url %pic.webcam 
  if ($pic(%pic.webcam) == 0) goto error | goto null
  :error
  /echo -s ERROR: Can not open file, possible reasons may be damaged or incompeleted, server might down,email us if you encounter problem.
  /window -c @Webcam- $+ %camfile.url
  goto end
  :null
  :end
  ;/unset %pic.*
}


;- Dialog codes

alias wbc { /dialog -m te te }



dialog te {
  title "EaSiWebCams"
  size -1 -1 114 48
  option dbu
  combo 2, 11 10 88 75, drop
  button "Goto!" 3, 8 28 29 9, 
  box "List of Webcams" 4, 3 2 107 40,
  button "ShowCam" 5, 43 28 29 9, ok
  button "View Profile" 6, 76 28 31 9,
}

dialog web.profiles {
  title "Webcams Profiles"
  size -1 -1 237 131
  option dbu
  box "Webcams Profiles" 2, 7 5 227 102,
  text "Name:" 3, 11 17 19 9,
  text "URL:" 4, 11 30 17 8,
  text "Channel Name:" 5, 11 44 41 7,
  text "IRC Server:" 6, 11 58 32 7,
  text "Notes:" 7, 11 77 16 7,
  edit "" 8, 33 17 107 10,
  edit "" 9, 33 29 189 10,
  edit "" 10, 55 43 96 10,
  edit "" 11, 45 58 126 10,
  edit "" 12, 29 77 181 10,
  button "Add/Apply" 13, 9 116 31 10,
  box "<- Prev / Next ->" 14, 148 107 86 21,
  box "Profile Controls" 15, 6 108 139 21,
  button "Delete" 16, 43 116 31 10, 
  check "" 17, 224 28 10 10,
  text "Webcams Refresh rate:" 18, 11 94 58 7,
  edit "" 19, 70 92 39 10,
  text "Seconds" 21, 111 95 25 7,
  button "Close" 20, 109 116 31 10, Ok
}

dialog profile.del {
  title "Do u Wish?"
  size -1 -1 118 62
  option dbu
  box "Delete Profile?" 2, 3 2 112 57,
  button "Yes" 3, 7 43 33 11, Ok
  button "Cancel" 4, 73 43 33 11, Cancel
  text "Do you wish to delete?" 5, 28 12 57 9,
  text "" 6, 19 29 81 10,
}



;dialog func code begin here

on *:dialog:te:init:0: {
  if (%webcamsetup == ready) goto main | goto setup
  :setup
  /hmake webcams 1000
  /hload webcams %mrc.folder $+ webcams.dat
  /hmake wcs 10
  /hadd wcs list.n $hget(webcams,0).item
  /set -u10000 %webcamsetup ready
  /set %list.tmp 0
  :main
  ;/echo de: %list.tmp
  /inc %list.tmp 1
  if ($hget(webcams,%list.tmp) == ready) goto main | goto cont
  :cont
  /did -a te 2 $gettok( $hget(webcams,%list.tmp).data ,2,124)
  if (%list.tmp == $hget(wcs,list.n)) goto end | goto main
  :error.1
  /echo -s WARNING unable to find webcams profiles
  /unset %webcamsetup
  :end
  if (%showcam == 1) goto 2 | goto 1
  :1
  /did -o te 5 1 Showcam
  goto fin
  :2
  /did -o te 5 1 Stop Cam
  :fin
  /unset %list.tmp
} 


;$gettok( $hget(webcams,%list.tmp) , $numtok( $hget(webcams,%list.tmp) ,124) ,124)))

on 1:dialog:te:sclick:3: {
  ;/echo -s u selected: $did(te,2) > $did(te,2).sel > $gettok( $hget(webcams, $did( te,2).sel ).data ,3,124) > $gettok( $hget(webcams, $did( te,2).sel ).data ,5,124)
  ;/echo -s irc: $gettok( $hget(webcams, $did( te,2).sel ).data ,6,124) chan: $gettok( $hget(webcams, $did( te,2).sel ).data ,7,124)

  if ( $gettok( $hget(webcams, $did( te,2).sel ).data ,7,124) == $null) goto end | goto cmds  
  :cmds
  /server $gettok( $hget(webcams, $did( te,2).sel ).data ,6,124)
  :end
}

on 1:dialog:te:sclick:5: {
  if ( $gettok( $hget(webcams, $did( te,2).sel ).data ,7,124) == $null) goto end | goto cmds
  :cmds
  if ( %showcam == 1) goto stopcam | goto showcam
  :stopcam
  /did -o te 5 1 Showcam
  /set -u1000 %showcam 0
  :chk.1 
  if ( $hget(wcs,showcam) == $null) goto cur.1 | goto cur.2
  :cur.1
  /.timer $+ $gettok( $hget(webcams, $did( te,2).sel ).data ,7,124) off
  goto sockcloses
  :cur.2
  /.timer $+ $hget(wcs,showcam) off
  :sockcloses
  /sockclose webcam*
  /echo -s -
  /echo -s *** Webcam Has been halt by user ***
  /echo -s -
  goto end
  :showcam
  /hadd wcs showcam $gettok( $hget(webcams, $did( te,2).sel ).data ,7,124)
  /wurl $gettok( $hget(webcams, $did( te,2).sel ).data ,3,124) $gettok( $hget(webcams, $did( te,2).sel ).data ,4,124)
  /.timer $+ $gettok( $hget(webcams, $did( te,2).sel ).data ,7,124) 0 $gettok( $hget(webcams, $did( te,2).sel ).data ,5,124) /wurl $gettok( $hget(webcams, $did( te,2).sel ).data ,3,124) $gettok( $hget(webcams, $did( te,2).sel ).data ,4,124)
  /did -o te 5 1 Stop Cam
  /set -u1000 %showcam 1
  :end
  HALT 
}

on 1:dialog:te:sclick:6: {
  /hadd wcs last $gettok( $hget(webcams, $did( te,2).sel ).data ,7,124)
  if ($dialog(web.profiles).title == $null) goto make1 | goto make2
  :make1
  /dialog -m web.profiles web.profiles
  /did -ra web.profiles 8 $gettok( $hget(webcams, $did( te,2).sel ).data ,2,124)
  /did -a web.profiles 9 $gettok( $hget(webcams, $did( te,2).sel ).data ,3,124)
  if ( $gettok( $hget(webcams, $did( te,2).sel ).data ,4,124) == 0) goto ucheck | goto check
  :ucheck
  /did -u web.profiles 17
  goto jump.1
  :check
  /did -c web.profiles 17
  :jump.1
  /did -a web.profiles 10 $gettok( $hget(webcams, $did(te,2).sel ).data , $numtok( $hget(webcams, $did(te,2).sel ).data ,124) ,124)))
  /did -a web.profiles 11 $gettok( $hget(webcams, $did( te,2).sel ).data ,6,124)
  /did -a web.profiles 19 $gettok( $hget(webcams, $did( te,2).sel ).data ,5,124)
  goto end
  :make2
  /wpu1
  :end
}

on 1:dialog:web.profiles:sclick:13:{
  :chk-chan-name
  if ( $did(web.profiles,10) == $null) goto ad-chan | goto normal
  :ad-chan
  /set %wcs.nam.tmp $chr(35) $+ $replace( $did(web.profiles,8) ,$chr(32) ,+)  
  if ( $did(web.profiles,11) == $null) goto ad-irc | goto hadd.1
  :ad-irc
  set %wcs.irc.tmp irc.none.net:6661
  /hadd webcams %wcs.nam.tmp $hash($did(web.profiles,8) ,32) $+ $chr(124) $+ $did(web.profiles,8) $+ $chr(124) $+ $did(web.profiles,9) $+ $chr(124) $+ $did(web.profiles,17).state $+ $chr(124) $+ $did(web.profiles,19) $+ $chr(124) $+ %wcs.irc.tmp $+ $chr(124) $+ %wcs.nam.tmp
  goto hdel-chk
  :hadd.1
  /hadd webcams %wcs.nam.tmp $hash($did(web.profiles,8) ,32) $+ $chr(124) $+ $did(web.profiles,8) $+ $chr(124) $+ $did(web.profiles,9) $+ $chr(124) $+ $did(web.profiles,17).state $+ $chr(124) $+ $did(web.profiles,19) $+ $chr(124) $+ $did(web.profiles,11) $+ $chr(124) $+ %wcs.nam.tmp
  goto hdel-chk
  :normal
  /hadd webcams $did(web.profiles,10) $hash($did(web.profiles,8) ,32) $+ $chr(124) $+ $did(web.profiles,8) $+ $chr(124) $+ $did(web.profiles,9) $+ $chr(124) $+ $did(web.profiles,17).state $+ $chr(124) $+ $did(web.profiles,19) $+ $chr(124) $+ $did(web.profiles,11) $+ $chr(124) $+ $did(web.profiles,10)
  :hdel-chk
  if (( $did(web.profiles,10) == $hget(wcs,last)) || ( $hget(wcs,last) == $null)) goto miss.1 | goto hdel
  :hdel
  /hdel webcams $hget(wcs,last)
  :miss.1
  /hsave -o webcams %mrc.folder $+ webcams.dat
  ;/echo -s h: $did( te,2) $hash($did(web.profiles,8) ,32) $+ $chr(124) $+ $did(web.profiles,8) $+ $chr(124) $+ $did(web.profiles,9) $+ $chr(124) $+ $did(web.profiles,17).state $+ $chr(124) $+ $did(web.profiles,19) $+ $chr(124) $+ $did(web.profiles,11) $+ $chr(124) $+ $did(web.profiles,10)
  /wpu2
  :update.timer

  if ( $timer( $gettok( $hget(webcams, $did( web.profiles,10) ) ,7,124) ) == 1) goto time.cont | goto end
  :time.cont

  if ( $timer( $gettok( $hget(webcams, $did( web.profiles,10) ) ,7,124) ).delay == $did( web.profiles,10) ) goto end | goto time.reset
  :time.reset

  /.timer $+ $gettok( $hget(webcams, $did( web.profiles,10) ) ,7,124) off
  /.timer $+ $gettok( $hget(webcams, $did( web.profiles,10) ) ,7,124) 0 $gettok( $hget(webcams, $did( web.profiles,10) ) ,5,124) /wurl $gettok( $hget(webcams, $did( web.profiles,10) ) ,3,124) $gettok( $hget(webcams, $did( web.profiles,10) ).data ,4,124)

  :end
}

on 1:dialog:web.profiles:sclick:16:{
  /dialog -m profile.del profile.del
}

on 1:dialog:profile.del:sclick:3:{

  /hdel webcams $did(web.profiles,10)
  /hsave -o webcams %mrc.folder $+ webcams.dat
  /wpu1
  /wpu2


}

;- alias code

alias wpu1 { 
  ;/echo -s de: wpu1 > $1
  /hadd wcs last $gettok( $hget(webcams, $did( te,2).sel ).data ,7,124)
  /did -ra web.profiles 8 $gettok( $hget(webcams, $did( te,2).sel ).data ,2,124)
  /did -ra web.profiles 9 $gettok( $hget(webcams, $did( te,2).sel ).data ,3,124)
  if ( $gettok( $hget(webcams, $did( te,2).sel ).data ,4,124) == 0) goto ucheck | goto check
  :ucheck
  /did -u web.profiles 17
  goto jump.1
  :check
  /did -c web.profiles 17
  :jump.1
  /did -ra web.profiles 10  $gettok( $hget(webcams, $did(te,2).sel ).data , $numtok( $hget(webcams, $did(te,2).sel ).data ,124) ,124)))
  /did -ra web.profiles 11  $gettok( $hget(webcams, $did( te,2).sel ).data ,6,124)
  /did -ra web.profiles 19  $gettok( $hget(webcams, $did( te,2).sel ).data ,5,124)
  :end
}


alias wpu2 { 


  ;/echo -s de: wpu2

  /unset %webcamsetup 
  /hfree -w w*
  if ( $dialog(te).title == $null) goto make.1 | goto cont.1 
  :cont.1
  /did -r te 2
  if (%webcamsetup == ready) goto main | goto setup
  :setup
  /hmake webcams 1000
  /hload webcams %mrc.folder $+ webcams.dat
  /hmake wcs 10
  /hadd wcs list.n $hget(webcams,0).item
  /set -u10000 %webcamsetup ready
  /set %list.tmp 0
  :main
  ;/echo de: %list.tmp
  /inc %list.tmp 1
  if ($hget(webcams,%list.tmp) == ready) goto main | goto cont.2
  :cont.2
  if ( $dialog(te).title == $null) goto make.2 | goto cont.3
  :cont.3
  /did -a te 2 $gettok( $hget(webcams,%list.tmp).data ,2,124)
  if (%list.tmp == $hget(wcs,list.n)) goto end | goto main
  :error.1
  /echo -s WARNING unable to find webcams profiles
  /unset %webcamsetup
  :end
  /did -c te 2 $did(te,2).sel
  /unset %list.tmp
  goto fin
  :make.1
  /dialog -m te te
  goto cont.1
  :make.2
  /dialog -m te te
  goto cont.3
  :fin
}

alias wbc.chan {
  :chk
  if ($dialog(web.profiles).title == $null) goto chan | goto end
  :chan
  /dialog -m web.profiles web.profiles
  /did -ra web.profiles 8 $gettok( $hget(webcams, $chan ) ,2,124)
  /did -ra web.profiles 9 $gettok( $hget(webcams, $chan ) ,3,124)
  if ( $gettok( $hget(webcams, $chan ) ,4,124) == 0) goto ucheck | goto check
  :ucheck
  /did -u web.profiles 17
  goto jump.1
  :check
  /did -c web.profiles 17
  :jump.1
  /did -ra web.profiles 10  $gettok( $hget(webcams, $chan ) , $numtok( $hget(webcams, $chan ) ,124) ,124)))
  /did -ra web.profiles 11  $gettok( $hget(webcams, $chan ) ,6,124)
  /did -ra web.profiles 19  $gettok( $hget(webcams, $chan ) ,5,124)
  :end
}







;- old alias

alias -l fixwebcam {
  set %webcam.dump $1
  if (%fig.check == 1) goto main | goto setup
  :setup
  set %fig 0
  set %fig.check 1
  :main
  /bread %webcam.dump %fig 4 &fig
  set -u30 %fig.hex $bvar(&fig,1-99999999999999)
  if ($bvar(&fig,0) == 0) goto null | goto scan
  :scan
  if (%fig.hex == 13 10 13 10) goto found | goto nope
  :nope
  inc %fig
  goto main
  :null
  /echo -s None found! 
  goto end
  :found
  /echo -s Found: %fig.hex Matchs : BeginByte: $calc(%fig + 4) : Number of bytes needed to be copied: $abs($calc($calc(%fig + 4) - $file(%webcam.dump).size)))
  goto  end
  :end
  set %fig.tp $calc(%fig + 4)
  set %fig 0

}

alias -l complie { 
  /echo -s [PLEASE WAIT] Processing File.....
  :setup
  set %webcam.dump.tp $1
  set %tp %fig.tp
  set %tp.new 0
  :main
  /bread %webcam.dump.tp %tp 1 &tp
  /bwrite tp-cam.jpg %tp.new 1 &tp
  if ($bvar(&tp,0) == 0) goto fin | goto loop
  :loop 
  /echo -s Dumpfile: %tp bytes / newfile: %tp.new Bytes > $bvar(&tp,0)
  inc %tp 1
  inc %tp.new 1
  goto main
  :fin
  /echo -s File Processing Compeleted.
  /showcam tp-cam.jpg
}
