;#########################################
;#
;# mIRC2 v2.9 by EaSi (easi2search.com)
;# released March 5, 2001
;#
;# main mirc2 file, general commands, identifiers
;#
;#########################################
on *:load:{
  if ($version < 5.82) {
    echo -s This addon will not work with versions older than 5.82
    unload -rs $script(mirc2.mrc)
    halt
  }
  if ($version > 5.82) echo -s This addon may not work properly with versions beyond 5.82
  var %f1 = $scriptdir $+ mirc2.dcc, %f2 = $scriptdir $+ mirc2.irc
  if (($isfile(%f1) == $false) || ($isfile(%f2) == $false)) {
    echo -s Unable to find $nopath(%f1)
    echo -s Aborting load...
    unload -rs $script
    halt
  }
  .load -rs " $+ %f1 $+ "
  .load -rs " $+ %f2 $+ "
  echo -s mIRC2 Addon loaded. Type /mirc2 <server> <port> to launch.
}
menu menubar {
  &mIRC2
  .&Launch...:mirc2 $?="Enter server name and port (or click cancel)"
  .-
  .$pcv(@server,irc.1):mirc2 $pcv(@server,irc.1) $pcv(@port,irc.1)
  .$pcv(@server,irc.2):mirc2 $pcv(@server,irc.2) $pcv(@port,irc.2)
  .$pcv(@server,irc.3):mirc2 $pcv(@server,irc.3) $pcv(@port,irc.3)
  .$pcv(@server,irc.4):mirc2 $pcv(@server,irc.4) $pcv(@port,irc.4)
  .$pcv(@server,irc.5):mirc2 $pcv(@server,irc.5) $pcv(@port,irc.5)
  .-
  .&Unload...:m2unload
}
alias m2unload {
  if ($?!="Are you sure you want to unload mIRC2?" == $false) return
  if ($sock(mircii.dcc.*,1)) socklose mircii.dcc.*
  var %s = $sock(*,0), %t = 1
  while (%s) {
    if ($m2snm($sock(*,%s),1) == mIRC2) sockclose $sock(*,%s)
    dec %s
  }
  while ($ini($shortfn($mircini),%t)) {
    var %i = $ifmatch
    if (($pcv(@me,%i)) || (irc.* iswm %i)) remini " $+ $mircini $+ " %i
    inc %t
  }
  remini " $+ $mircini $+ " mirc @dclick.com
  unset %m2.* %mirc2.local
  if ($isfile($m2pfile)) .remove " $+ $m2pfile $+ "
  if ($script(mirc2.dcc)) unload -rs " $+ $ifmatch $+ "
  if ($script(mirc2.irc)) unload -rs " $+ $ifmatch $+ "
  unload -rs " $+ $script $+ "
}
alias m2hmake { if ($hget($1) == $null) hmake $1 9999 }
alias m2hadd { m2hmake $1 | hadd $1 $2 $addtok($hget($1,$2),$3-,32) }
alias m2hrem {
  if ($hget($1)) {
    var %m2.h = $hget($1,$2)
    if ($len($remtok(%m2.h,$3,32))) hadd $1 $2 $remtok(%m2.h,$3,1,32)
    else hdel $1 $2
  }
}
alias m2grab: {
  var %gn = $calc($findtok($1-,$wildtok($1-,:*,2,32),1,32) - 1)
  return $gettok($1-,$m2+(5-,%gn),32) $right($gettok($1-,$m2+($calc(%gn + 1),-),32),-1)
}
alias m2isticks { return $iif((($calc($ctime - $1) > 604800) || ($calc($ctime - $1) < -604800)),$true,$false) }
alias m2win { return @ $+ $2 $+ $m2.brak($m2.snum($1)) }
alias m2achan {
  var %cl = $hget($1,channels), %c = 1
  while ($gettok(%cl,%c,32)) {
    m2techo $1 $ifmatch $3-
    inc %c
  }
}
alias m2cchan {
  var %c | if ($1 isnum) { var %c = $1 | tokenize 32 $2- }
  var %i = 1, %winlist = $hget($1,channels), %m2.f = 1
  while ($gettok(%winlist,%i,32)) {
    var %twin = $ifmatch
    if ($m2ison($1,$2,%twin)) { var %m2.f = 0 | m2techo %c $1 %twin $3- }
    inc %i
  }
  if (%m2.f) m2secho %c $1 $3-
}
alias m2techo {
  var %c | if ($1 isnum) { var %c = $1 | tokenize 32 $2- }
  if ($window($m2win($1,$2))) echo %c -ti $m2win($1,$2) $3-
}
alias m2secho {
  if ($1 isnum) echo $1 -ti $m2win($2,Status) $3-
  else echo -ti $m2win($1,Status) $2-
}
alias m2aecho {
  var %c | if ($1 isnum) { var %c = $1 | tokenize 32 $2- }
  if ($m2gs($active) == $m2.snum($1)) echo %c -ai $2-
  else m2secho %c $1 $2-
}
alias m2linesep {
  if ($1 == -s) var %m2l = $m2win($2,Status)
  elseif (($1 == -a) && ($m2gs($active) == $m2.snum($2))) var %m2l = $active
  else {
    if ($m2gs($1) == $m2.snum($2)) var %m2l = $1
    else var %m2l = $m2win($2,Status)
  }
  if ($line(%m2l,$line(%m2l,0)) != -) echo %m2l -
}
alias m2getchan {
  var %r = $left($right($mid($1,1,$pos($1,[,$count($1,[))),-1),-1)
  return $iif((Chat* iswm %r),$remove(%r,Chat),%r)
}
alias m2ison {
  var %m2.o = @ $+ $2, %m2.v = + $+ $2, %m2.h = $chr(37) $+ $2, %n = 1
  while ($hget($1,$m2+($3,.NamesList.,%n))) {
    var %m2.ilist = $ifmatch
    if ($istok(%m2.ilist,$2,32)) return $1-
    if ($istok(%m2.ilist,%m2.o,32)) return $1 %m2.o $3
    if ($istok(%m2.ilist,%m2.v,32)) return $1 %m2.v $3
    if ($istok(%m2.ilist,%m2.h,32)) return $1 %m2.h $3
    inc %n
  }
}
alias m2clearnicks { hdel -w $1 $2 $+ .NamesList.* }
alias m2addnick {
  var %na = 1, %len = $len($3-)
  while ($calc($len($hget($1,$m2+($2,.NamesList.,%na))) + %len) >= 800) { inc %na | continue }
  m2hadd $1 $m2+($2,.NamesList.,%na) $3-
  hadd $1 $m2+($2,.NamesList.Total) %na
}
alias m2+ { return $remove($1-,$chr(32)) }
alias m2remnick {
  var %m2.rnick, %m2.r1 = @ $+ $3, %m2.r2 = + $+ $3, %m2.r3 = $chr(37) $+ $3, %nr = $hget($1,$m2+($2,.NamesList.Total))
  while ($hget($1,$m2+($2,.NamesList.,%nr))) {
    var %listr = $ifmatch
    var %itemr = $m2+($2,.NamesList.,%nr)
    if ($istok(%listr,$3,32)) var %m2.rnick = $3
    elseif ($istok(%listr,%m2.r1,32)) { var %m2.rnick = %m2.r1 | break }
    elseif ($istok(%listr,%m2.r2,32)) { var %m2.rnick = %m2.r2 | break }
    elseif ($istok(%listr,%m2.r3,32)) { var %m2.rnick = %m2.r3 | break }
    dec %nr
  }
  if (%m2.rnick) {
    m2hrem $1 %itemr %m2.rnick
    if ($hget($1,%itemr) == $null) hadd $1 $m2+($2,.NamesList.Total) $calc($hget($1,$m2+($2,.NamesList.Total)) - 1)
  }
}
alias m2delnick {
  var %c = $hget($1,channels), %xx = $numtok(%c,32)
  while (%xx) {
    m2remnick $1 $gettok(%c,%xx,32) $2
    dec %xx
  }
}
alias m2delnick.2 {
  var %m2.w = $m2.win(*,$1), %m2.x = 1
  while ($window(%m2.w,%m2.x)) {
    var %m2.tmp = $ifmatch
    if ($left($right(%m2.tmp,-1),1) isin @#) m2delnick.3 $1 %m2.tmp $2
    inc %m2.x
  }
}
alias m2delnick.3 {
  var %m2.do = @ $+ $3, %m2.dv = + $+ $3, %m2.dh = $chr(37) $+ $3
  var %m2.no = $m2cnick(%m2.do), %m2.nv = $m2cnick(%m2.dv), %m2.nh = $m2cnick(%m2.dh)
  var %m2.al = $3 %m2.no %m2.nv %m2.dh, %m2.d = 1
  while ($gettok(%m2.al,%m2.d,32)) {
    if ($fline($2,$ifmatch,1,1)) dline -l $2 $ifmatch
    inc %m2.d
  }
}
alias m2rn {
  dline -l $2-3
  aline -l $2 $m2cnick($5)
  m2repnick.2 $1 $m2getchan($2) $strip($4) $5
}
alias m2repnick {
  var %c = $hget($1,channels)
  var %n = $numtok(%c,32)
  while (%n) {
    m2repnick.2 $1 $gettok(%c,%n,32) $2-
    dec %n
  }
}
alias m2repnick.2 {
  var %m2.o1 = @ $+ $3, %m2.o2 = + $+ $3, %m2.o3 = $chr(37) $+ $3
  var %x = $hget($1,$m2+($2,.NamesList.Total))
  while (%x) {
    var %item = $m2+($2,.NamesList.,%x)
    var %old = $hget($1,%item)
    if ($istok(%old,$3,32)) { hadd $1 %item $reptok(%old,$3,$4,1,32) | break }
    elseif ($istok(%old,%m2.o1,32)) { hadd $1 %item $reptok(%old,%m2.o1,$4,1,32) | break }
    elseif ($istok(%old,%m2.o2,32)) { hadd $1 %item $reptok(%old,%m2.o2,$4,1,32) | break }
    elseif ($istok(%old,%m2.o3,32)) { hadd $1 %item $reptok(%old,%m2.o3,$4,1,32) | break }
    else dec %x
  }
}
alias m2repnick.3 {
  var %m2.c = $hget($1,channels)
  var %m2.i = $numtok(%m2.c,32)
  while (%m2.i) {
    if ($m2ison($1,$2,$gettok(%m2.c,%m2.i,32))) {
      var %m2.if = $ifmatch
      var %m2.ch = $gettok(%m2.if,3,32), %m2.on = $gettok(%m2.if,2,32)
      m2repnick.4 $1 %m2.ch %m2.on $3
    }
    dec %m2.i
  }
}
alias m2repnick.4 {
  var %w = $m2win($1,$2)
  if ($fline(%w,$m2cnick($3),1,1)) {
    dline -l %w $ifmatch
    aline -l %w $m2cnick($4)
  }
}
alias m2cnick { return $replace($1-,`,$m2pck(`),$chr(124),$m2pck($chr(124)),$chr(91),$m2pck($chr(91)),$chr(93),$m2pck($chr(93)),$chr(123),$m2pck($chr(123)),$chr(125),$m2pck($chr(125)),\,$m2pck(\),_,$m2pck(_),^,$m2pck(^)) }
alias m2pck { return $chr(3) $+ $m2c(nicklist) $+ $1 $+  }
alias m2addchan { m2hadd $1 channels $2 }
alias m2remchan { m2hrem $1 channels $2 }
alias m2chmode {
  if (($4 == +o) && ($m2isop($1,$3,$5) == $null)) { m2repnick.4 $1 $3 $5 @ $+ $5 | m2repnick.2 $1 $3 $5 @ $+ $5 }
  if ($4 == -o) { m2repnick.4 $1 $3 @ $+ $5 $5 | m2repnick.2 $1 $3 @ $+ $5 $5 }
  if (($remove($4,+,-) isin vh) && ($m2isop($1,$3,$5))) return
  if (($4 == +v) || ($4 == +h)) {
    var %m2.pre = $iif(v isin $4,+,$chr(37))
    m2repnick.4 $1 $3 $5 %m2.pre $+ $5
    m2repnick.2 $1 $3 $5 %m2.pre $+ $5
  }
  if (($4 == -v) || ($4 == -h)) {
    var %m2.pre = $iif(v isin $4,+,$chr(37))
    m2repnick.4 $1 $3 %m2.pre $+ $5 $5
    m2repnick.2 $1 $3 %m2.pre $+ $5 $5
  }
}
alias m2modeparse {
  m2techo $m2c(mode) $1 $4 *** $m2.nick($2) sets mode: $5-
  var %m2.inc = 1, %m2.pos = 0
  while ($mid($5,%m2.inc,1)) {
    var %m2.m = $ifmatch
    if (%m2.m isin +-) { var %m2.pre = %m2.m | inc %m2.inc | continue }
    elseif (%m2.m isin ikmnpst) m2chmode $1 $m2.nick($2) $4 %m2.pre $+ %m2.m
    else { inc %m2.pos | m2chmode $1 $m2.nick($2) $4 %m2.pre $+ %m2.m $gettok($6-,%m2.pos,32) }
    inc %m2.inc
  }
}
alias m2isop {
  var %m2.t = $hget($1,$m2+($2,.NamesList.Total)), %m2.op = @ $+ $3
  while (%m2.t) {
    if ($istok($hget($1,$m2+($2,.NamesList.,%m2.t)),%m2.op,32)) return 1
    dec %m2.t
  }
}
alias m2flood {
  var %p = $prop
  goto %p
  :time | return $m2if($pcv(FLOOD_TIME,$1),15)
  :max | return $m2if($pcv(FLOOD_MAX,$1),6)
  :%p
}
alias pcv { return $readini -n " $+ $mircini $+ " $$2 $1 }
alias psv { var %m2.file = $shortfn($mircini) | if ($len($3)) writeini -n %m2.file $2 $1 $3- | else remini %m2.file $$2 $1 }
alias m2wino {
  var %sn = irc. $+ $m2gs($2)
  m2hadd %sn windows $2
  if ($window($2) == $null) window $1-2 $pcv($m2+(@pos.,$m2wint($2)),%sn) @ $+ $iif( isin $2,m2status,$iif($m2ischan($m2getchan($2)),m2chan,m2query)) $pcv($m2+(@font.,$m2wint($2)),%sn)
}
alias m2winc {
  var %sn = irc. $+ $m2gs($1), %wt = $m2wint($1)
  m2hrem %sn windows $1
  psv @pos. $+ %wt %sn $window($1).x $window($1).y $window($1).w $window($1).h
  psv @font. $+ %wt %sn $window($1).font $window($1).fontsize
  window -c $1
}
alias m2wint {
  if (@Chat*:* iswm $1) return chat
  return $iif($m2ischan($m2getchan($1)),channels,$iif( isin $1,status,queries))
}
alias m2winstat { if ($prop == font) return $window($1).font $window($1).fontsize | return $window($1).x $window($1).y $window($1).w $window($1).h }
alias m2msg { m2s $1 PRIVMSG $2 : $+ $3- | m2techo $1 $2 < $+ $hget($1,me) $+ > $3- }
alias m2gs {
  var %m2.pos = $calc($pos($1,[,$count($1,[)) + 1)
  return $mid($1,%m2.pos,$calc($pos($1,],$count($1,])) - %m2.pos))
}
alias m2ischan {
  if (($1 == $null) && ($left($m2getchan($active),1) isin &#)) return 1
  if ($left($1,1) isin &#) return 1
  if ((@* iswm $1) && ($left($m2getchan($1),1) isin &#)) return 1
}
alias m2mchan { if ($left($1,1) !isin &#) return $chr(35) $+ $1 | return $1 }
alias m2if { return $iif($1,$1,$2) }
alias m2dport {
  var %m2.port = $r(1500,3000)
  while ($portfree(%m2.port) == $false) { var %m2.port = $r(1500,3000) | continue }
  return %m2.port
}
alias m2.nick { return $right($gettok($1,1,33),-1) }
alias m2.host { return $gettok($1,2,33) }
alias m2.win  { return $m2+(@,$iif(:* iswm $1,$right($gettok($1,1,33),-1),$1),$m2.brak($m2.snum($2))) }
alias m2.snum { return $remove($1,irc.) }
alias m2.brak { return $m2+([,$1,]) }
alias ism2win { return $istok($hget($m2+(irc.,$remove($mid($1,$calc($pos($1,[,$count($1,[)) + 1)),])),windows),$1,32) }
alias m2.kill {
  if ($readini " $+ $mircini $+ " text quit) m2s $1 QUIT : $+ $ifmatch
  .timer. $+ $1 $+ .* off
  if ($m2snm($1,2) == CONNECTING) m2secho $m2c(info) $1 *** Cancelled connect
  elseif ($m2snm($1,2) == CONNECTED) {
    var %m2dm = *** Disconnected
    if ($line($m2win($1,Status),$line($m2win($1,Status),0)) != %m2dm) m2secho $m2c(info) $1 %m2dm
  }
  m2exit $1
  sockclose $1
  if ($hget($1)) hfree $1
  var %k = $m2+(@*,$m2.brak($remove($1,irc.))), %t = $window(0), %s = $m2+(@Status,$m2.brak($remove($1,irc.)))
  while (%t) {
    if ($window(%t) == %s) { titlebar $window(%t) | dec %t | continue }
    if (%k iswm $window(%t)) m2winc $window(%t)
    dec %t
  }
  var %s = 1, %m2.retain = 0
  while ($sock(*,%s)) {
    if ($m2snm($ifmatch,1) == mIRC2) { var %m2.retain = 1 | break }
    inc %s
  }
  if (%m2.retain == 0) unset %mirc2.local
}
alias m2exit {
  if ($hget($1,me)) psv @me $1 $ifmatch
  if ($hget($1,server)) psv @server $1 $ifmatch
  if ($sock($1).port) psv @port $1 $ifmatch
}
alias m2s { if ($sock($1)) sockwrite -tn $1 $2- | else m2.kill $1 }
alias m2c { return $colour($1-) }
on *:close:@Status[*]:{
  m2winc $target
  var %s = irc. $+ $remove($target,@Status,$chr(91),$chr(93))
  m2.kill %s | psv @mIRC %s
}
on *:close:@Channels[*]:{
  m2savepos $target $target
  window -c $target $+ 1
  window -c $target $+ 2
  window -c $target $+ 3
}
on *:close:@Chat*:{
  if (@Chat*:* iswm $target) {
    var %m2.sc = $gettok($target,2,58)
    var %m2.sc2 = $m2+(mircii.dcc.,%m2.sc)
    if (($sock(%m2.sc)) && ($m2snm(%m2.sc,1) == mIRC2)) m2dcckill $m2gs($target) $m2snm(%m2.sc,2) %m2.sc
    elseif (($sock(%m2.sc2)) && ($m2snm(%m2.sc2,1) == mIRC2)) m2dcckill $m2gs($target) $m2snm(%m2.sc2,2) %m2.sc2
    m2savepos $target $m2wint($target)
  }
}
on *:close:@:{
  var %m2.wt = $target, %wt = $m2wint($target)
  if ($ism2win(%m2.wt)) {
    var %m2.r = $m2+(irc.,$m2gs(%m2.wt))
    if ((@#* iswm %m2.wt) || (@&* iswm %m2.wt)) { m2s %m2.r PART $m2getchan(%m2.wt) | m2remchan %m2.r $m2getchan(%m2.wt) }
    m2hrem %m2.r windows %m2.wt
    m2savepos %m2.wt %wt
    return
  }
  if ((@Channels[*]1 iswm $target) || (@Channels[*]2 iswm $target) || (@Channels[*]3 iswm $target)) {
    var %w = $m2.win(Channels,$m2gs($target))
    window -c %w $+ 1
    window -c %w $+ 2
    window -c %w $+ 3
    window -c %w
  }
  var %i = $sock(*,0)
  while (%i) {
    var %sock = $sock(*,%i)
    if (($m2snm(%sock,1) == mIRC2) && ($m2snm(%sock,6) == $target)) {
      sockclose %sock
      if ($hget(%sock)) hfree %sock
      .timer $+ %sock off
    }
    else dec %i
  }
  unset %m2.filercvd. [ $+ [ $target ] ]
}
menu @m2status {
  &Spawn
  .&Specify...:mirc2 $$?="Enter server name to connect to..."
  .-
  .$pcv(@server,irc.1):mirc2 $pcv(@server,irc.1) $pcv(@port,irc.1)
  .$pcv(@server,irc.2):mirc2 $pcv(@server,irc.2) $pcv(@port,irc.2)
  .$pcv(@server,irc.3):mirc2 $pcv(@server,irc.3) $pcv(@port,irc.3)
  .$pcv(@server,irc.4):mirc2 $pcv(@server,irc.4) $pcv(@port,irc.4)
  .$pcv(@server,irc.5):mirc2 $pcv(@server,irc.5) $pcv(@port,irc.5)
  -
  &Connect
  .&Specify...:if ($$?="Enter server name to connect to...") { m2.kill $m2ms | mirc2 $! }
  .-
  .$pcv(@server,irc.1):var %z = $m2ms | m2.kill %z | mirc2 %z $pcv(@server,irc.1) $pcv(@port,irc.1)
  .$pcv(@server,irc.2):var %z = $m2ms | m2.kill %z | mirc2 %z $pcv(@server,irc.2) $pcv(@port,irc.2)
  .$pcv(@server,irc.3):var %z = $m2ms | m2.kill %z | mirc2 %z $pcv(@server,irc.3) $pcv(@port,irc.3)
  .$pcv(@server,irc.4):var %z = $m2ms | m2.kill %z | mirc2 %z $pcv(@server,irc.4) $pcv(@port,irc.4)
  .$pcv(@server,irc.5):var %z = $m2ms | m2.kill %z | mirc2 %z $pcv(@server,irc.5) $pcv(@port,irc.5)
  &Disconnect:m2.kill $m2ms
  -
  &Options
  .&Perform on connect...:run notepad " $+ $m2pfile $+ "
  .&Version reply...:%mirc2.version = $$?="Enter new version reply"
  .&Dclick on nicklist
  ..&Kick $iif($pcv(@dclick.com,mirc) == k,*):psv @dclick.com mIRC k
  ..Kick&ban $iif($pcv(@dclick.com,mirc) == kb,*):psv @dclick.com mIRC kb
  ..&Whois $iif($pcv(@dclick.com,mirc) == wi,*):psv @dclick.com mIRC wi
  ..W&hois++ $iif($pcv(@dclick.com,mirc) == wii,*):psv @dclick.com mIRC wii
  ..&Ping $iif($pcv(@dclick.com,mirc) == p,*):psv @dclick.com mIRC p
  ..&Query $iif($pcv(@dclick.com,mirc) == q,*):psv @dclick.com mIRC q
  .&CTCP flood
  ..&Time...:psv FLOOD_TIME $m2ms $$?="Allow CTCP requests in how many seconds?"
  ..&Max...:psv FLOOD_MAX $m2ms $$?="Allow how many requests?"
  ..-
  ..Current ( $+ $m2flood($m2ms).max in $m2flood($m2ms).time $+ ):/
  -
  &List channels:m2s $m2ms LIST
  &Join channel...:m2s $m2ms JOIN #$$?="Enter channel to join"
  -
  &Quit IRC...:m2s $m2ms QUIT : $+ $$?="Reason for quit?"
}
alias m2qmenu { if ($hget($m2ms,server)) return $1- }
alias m2pfile { return $scriptdir $+ mirc2.per }
menu @m2query {
  $m2qmenu(&Whois):m2ps WHOIS $m2act
  $m2qmenu(W&hois++):m2ps WHOIS $m2act $m2act
  $m2qmenu(&Ignore)
  .&30 secs:m2ignore $m2ms -pntiu30 $m2act 2 | window -c $active
  .&60 secs:m2ignore $m2ms -pntiu60 $m2act 2 | window -c $active
  .&90 secs:m2ignore $m2ms -pntiu90 $m2act 2 | window -c $active
  $m2qmenu(&CTCP)
  .&Ping:m2ctcp $m2ms $m2act PING $ticks
  .&Time:m2ctcp $m2ms $m2act TIME
  .&Version:m2ctcp $m2ms $m2act VERSION
  .-
  .&Other...:m2ctcp $m2ms $m2act $$?="Enter CTCP request"
  $m2qmenu(&DCC)
  .&Chat:m2dcc.chat $m2ms $ip $m2act
  .&Send...:m2dcc.send $m2ms $ip $m2act
}
menu @m2chan {
  dclick:{
    if ($1) {
      var %n = $remove($strip($line($active,$1,1)),@,+,%), %o = $pcv(@dclick.com,mIRC)
      if (%o == k) m2s $m2ms KICK $m2act %n : $+ $?="Enter reason"
      elseif (%o == kb) m2kickban $m2ms $m2act %n $?="Enter reason"
      elseif (%o == wi) m2s $m2ms WHOIS %n
      elseif (%o == wii) m2s $m2ms WHOIS %n %n
      elseif (%o == p) m2ctcp $m2ms %n PING $ticks
      else m2wino -ek $m2.win(%n,$m2ms)
    }
  }
  $m2menu(n,&Whois):m2s $m2ms WHOIS $m2snick
  $m2menu(n,&Whois++):m2s $m2ms WHOIS $m2snick $m2snick
  $m2menu(n,&Query):m2wino -ek $m2.win($m2snick,$m2ms)
  -
  $m2menu(n,&Control)
  .&Quick kickban:m2kickban $m2ms $m2act $m2snick bye
  .&Kick:m2s $m2ms KICK $m2act $m2snick
  .Kick (&why):m2s $m2ms KICK $m2act $m2snick : $+ $$?="Enter reason for kick"
  .&Ban, Kick:m2kickban $m2ms $m2act $m2snick $?="Enter reason for kick, cancel for no reason"
  .Quick ba&n:m2ban $m2ms $m2snick 2
  .&Timed ban
  ..30 secs:m2ban $m2ms 30 $m2snick 
  ..60 secs:m2ban $m2ms 60 $m2snick
  ..90 secs:m2ban $m2ms 90 $m2snick
  .-
  .&Op:m2s $m2ms MODE $m2act +o $m2snick
  .&Deop:m2s $m2ms MODE $m2act -o $m2snick
  .&Voice:m2s $m2ms MODE $m2act +v $m2snick
  .D&evoice:m2s $m2ms MODE $m2act -v $m2snick
  $m2menu(n,&Ignore)
  .&30 seconds:m2ignore $m2ms -pntiu30 $m2snick 3
  .&60 seconds:m2ignore $m2ms -pntiu60 $m2snick 3
  .&90 seconds:m2ignore $m2ms -pntiu90 $m2snick 3
  $m2menu(n,&CTCP)
  .&Ping:m2ctcp $m2ms $m2snick PING $ticks
  .&Version:m2ctcp $m2ms $m2snick VERSION
  .&Finger:m2ctcp $m2ms $m2snick FINGER
  .-
  .&Other...:m2ctcp $m2ms $m2snick $$?="Enter CTCP request"
  $iif(%mirc2.local,$m2menu(n,&DCC))
  .&Chat:m2dcc.chat $m2ms %mirc2.local $m2snick
  .&Send...:m2dcc.send $m2ms %mirc2.local $m2snick
  -
  $m2menu(&Join...):m2s $m2ms JOIN $$?="Enter channel name and key to join"
  $m2menu(&Part):m2s $m2ms PART $m2act
  $m2menu(&CTCP)
  .&Ping:m2ctcp $m2ms $m2act PING $ticks
  .&Finger:m2ctcp $m2ms $m2act FINGER
  .&Version:m2ctcp $m2ms $m2act VERSION
  .-
  .&Other...:{
    if ($$?="Enter CTCP request") var %m2.crq = $upper($!)
    if (%m2.crq == PING) %m2.crq = PING $ticks
    m2ctcp $m2ms $m2act %m2.crq
  }
  -
  $m2menu(&Quit IRC...):m2s $m2ms QUIT : $+ $$?="Enter reason for quit"
}
alias m2ctcp {
  m2s $1 PRIVMSG $2 : $+ $3- $+ 
  m2aecho $m2c(ctcp) $1 -> $chr(91) $+ $2 $+ $chr(93) $upper($3) $iif($3 != PING,$4-)
}
alias m2kickban {
  hadd $1 kbchan. $+ $$3 $$2
  hadd $1 kbreas. $+ $$3 $4-
  m2s $1 USERHOST $$3
}
alias m2ban {
  if ($m2ischan($m2act) != 1) halt
  var %m2a = $m2act, %m2t = 0
  if (($2 isnum) && ($2 > 1)) var %m2t = $2, %m2m = $3, %m2h = $4
  else var %m2m = $2, %m2h = $3
  if ((* isin %m2m) && (*!*@* iswm %m2m)) {
    m2s $1 MODE %m2a +b %m2m
    if (%m2t) .timer. $+ $1 $+ . $+ $ticks $+ . $+ %m2a 1 %m2t m2s $1 MODE %m2a -b %m2m
    return
  }
  hadd $1 ban.chan. $+ %m2m %m2a
  hadd $1 ban.time. $+ %m2m $iif(%m2t,%m2t,0)
  hadd $1 ban.type. $+ %m2m $iif(%m2h isnum,%m2h,2)
  m2s $1 USERHOST %m2m
}
menu @m2* {
  -
  $m2menu(&Window)
  .&Change font
  ..&Current...:font
  ..C&hannels...:if ($m2fontdlg) m2font $m2ms chan $ifmatch
  ..&DCC Chats...:if ($m2fontdlg) m2font $m2ms chat $ifmatch
  ..&Queries...:if ($m2fontdlg) m2font $m2ms query $ifmatch
  ..-
  ..&All windows...:if ($m2fontdlg) m2font $m2ms all $ifmatch
  .C&lear:clear
  .&Fit to mIRC:m2fitwin
}
alias m2fontdlg {
  var %a = @m2dlg $+ $ticks
  window -pfh +d %a 50 50 1 1 cancel 13
  window -a %a | font
  if ($window(%a).font == cancel) { window -c %a | return }
  var %fontname = $window(%a).font, %fontsize = $window(%a).fontsize
  window -c %a
  if ($prop == font) return %fontname
  if ($prop == size) return %fontsize
  return %fontsize %fontname
}
alias m2savepos {
  var %m2.gs = irc. $+ $m2gs($1)
  psv @pos. $+ $2 %m2.gs $m2winstat($1)
  psv @font. $+ $2 %m2.gs $m2winstat($1).font
}
#mirc2list off
menu @Channels {
  &Stop listing:m2ps LIST STOP
}
#mirc2list end
#mirc2list.complete on
menu @Channels {
  &Join Channel:if ($sline($active,1)) m2ps JOIN $gettok($ifmatch,1,32)
  &Show users:if ($sline($active,1)) m2ps NAMES $gettok($ifmatch,1,32)
  -
  Sort &by
  .&Name:if ($sline($active,1)) m2chlsort name $m2ms
  .&User:if ($sline($active,1)) m2chlsort user $m2ms
  .&Topic:if ($sline($active,1)) m2chlsort topic $m2ms
  -
  &Visit Website:if ($wildtok($strip($sline($active,1)),http://*,1,32)) run $ifmatch | elseif ($wildtok($strip($sline($active,1)),http://*,1,32)) run $ifmatch
  Save to &file:savebuf $active $$sfile($m2+($gettok($hget($m2ms,server),-2,46),.txt),- Save to file?)
}
#mirc2list.complete end
alias m2fitwin { window $active 0 0 $window(-3).w $window(-3).h }
alias m2snick { return $strip($remove($sline($active,1),@,+,%)) }
alias m2menu { if ($1 == n) { if ($mouse.lb) return $2- } | else { if ($mouse.lb == $false) return $1- } }
alias m2act { return $m2getchan($active) }
alias m2ps { m2s $m2ms $1- }
alias m2ms { return irc. $+ $m2gs($active) }
alias m2online {
  var %n = 1, %a
  while ($notify(%n)) {
    %a = %a $ifmatch
    inc %n
  }
  m2s $1 ISON : $+ %a
}
alias m2notify {
  var %x = 1, %m2.blah = $1, %y = 0
  while ($notify(%x)) {
    var %m2.nnick = $ifmatch
    var %m2.notfy = $m2+(@notify.,%m2.nnick)
    if ($istok($2-,%m2.nnick,32)) {
      if ($hget($1,%m2.notfy) != online) {
        hadd $1 %m2.notfy online
        m2secho $m2c(notify) $1 *** %m2.nnick is on IRC
        hadd $1 NOTIFY_CHECK: 1
        inc %y
      }
    }
    else {
      if ($hget($1,%m2.notfy) == online) {
        hadd $1 %m2.notfy offline
        m2secho $m2c(notify) $1 *** %m2.nnick has left IRC
      }
      elseif ($hget($1,%m2.notfy) == $null) hadd $1 %m2.notfy offline
    }
    inc %x
  }
  if ((%y == 0) && ($hget($1,NOTIFY_CHECK:) == $null)) {
    m2secho $m2c(notify) $1 *** No one in your notify list is on IRC
    hadd $1 NOTIFY_CHECK: 1
  }
}
alias m2tconv {
  var %m2.ts = $remove($duration($calc($ctime - $1)),hr,min,sec,s)
  return $m2tplug($gettok(%m2.ts,1,32)) $+ : $+ $m2tplug($gettok(%m2.ts,2,32)) $+ : $+ $m2tplug($gettok(%m2.ts,3,32))
}
alias m2tplug {
  if ($len($1) == 2) return $1
  if ($len($1) == 1) return 0 $+ $1
  return 00
}
on *:exit:unset %m2.* %mirc2.local
alias m2snm { return $gettok($sock($1).mark,$2,32) }
alias m2ignore {
  var %m2.switches, %m2.hostmask, %m2.masktype
  if ($4 != $null) {
    if (-* !iswm $2) var %m2.hostmask = $2, %m2.switches = pcntik, %m2.masktype = $iif($3 isnum 0-19,$3,2), %m2.masktype = $iif($4 isnum 0-19,$4,2)
    else var %m2.hostmask = $3, %m2.switches = $2, %m2.masktype = $iif($4 isnum 0-19,$4,2)
  }
  elseif ($3 != $null) {
    if (-* !iswm $2) var %m2.switches = pcntik, %m2.hostmask = $2, %m2.masktype = $iif($3 isnum 0-19,$3,2)
    else var %m2.switches = $2, %m2.hostmask = $3, %m2.masktype = 2
  }
  elseif ($2 != $null) {
    if (-* iswm $2) m2secho $m2c(info2) $1 * /ignore: insufficient parameters
    else var %m2.switches = pcntik, %m2.hostmask = $2, %m2.masktype = 2
  }
  else {
    m2secho $m2c(info2) $1 * /ignore: insufficient parameters
    return
  }
  m2ignore2 $1 %m2.switches %m2.hostmask %m2.masktype

}
alias m2ignore2 {
  var %m2.is = $remove($2,-,u,1,2,3,4,5,6,7,8,9,0), %m2.r, %m2.i = 1
  while ($mid(%m2.is,%m2.i,1)) {
    var %m2.tmp = $ifmatch
    if (%m2.tmp isin pcntik) %m2.r = %m2.r $+ $ifmatch
    elseif (%m2.tmp == r) { %m2.r = r | break }
    inc %m2.i
  }
  if (%m2.r == $null) %m2.r = pcntik
  var %m2.dur
  if ((u isin $2) && (%m2.r != r)) var %m2.dur = $remove($2,-,u,p,c,n,t,i,k)
  if (%m2.dur !isnum) var %m2.dur
  else var %m2.r = %m2.r $+ u $+ %m2.dur
  var %m2.targ = $iif($4 isnum 0-19,$iif(*!*@* iswm $3 && * !isin $3,$mask($3,$4),$3),$3)
  if (*!*@* iswm %m2.targ) m2ignore3 $1 %m2.r %m2.targ
  else {
    hadd $1 %m2.targ $+ .ignore_switches %m2.r
    hadd $1 %m2.targ $+ .ignore_masktype $4
    m2s $1 USERHOST %m2.targ
  }
}
alias m2aig {
  if ($hget($1,$m2+($2,.ignore_switches))) {
    var %m2.a1 = $ifmatch
    if ($hget($1,$m2+($2,.ignore_masktype))) var %m2.a2 = $mask($3,$ifmatch)
    else var %m2.a2 = $mask($3,2)
    hdel -w $1 $2 $+ .ignore_*
    m2ignore3 $1 %m2.a1 %m2.a2
  }
}
alias m2ignore3 {
  var %m2.hashname = $1 $+ .ignores
  var %m2.hashlist = $hget(%m2.hashname,list)
  m2hmake %m2.hashname 999
  var %m2.switches = $remove($2,u,r,1,2,3,4,5,6,7,8,9,0)
  if (r !isin $2) {
    if (u isin $2) {
      var %m2.secs = $remove($2,u,r,p,c,n,t,i,k)
      if (%m2.secs == 1) inc %m2.secs
      .timer. $+ $1 $+ . $+ $3 1 %m2.secs m2ignore3 $1 -r $3
    }
    hadd %m2.hashname $3 %m2.switches
    if ($istok(%m2.hashlist,$3,32)) m2secho $m2c(info2) $1 *** Updated ignore switches for $3
    else {
      m2hadd %m2.hashname list $3
      if (%m2.secs) m2secho $m2c(info2) $1 *** Added $3 to ignore list for %m2.secs secs
      else m2secho $m2c(info2) $1 *** Added $3 to ignore list
    }
  }
  else {
    if ($istok(%m2.hashlist,$3,32)) {
      m2hrem %m2.hashname list $3
      hdel %m2.hashname $3
      m2secho $m2c(info2) $1 *** Removed $3 from ignore list
      .timer. $+ $1 $+ . $+ $3 off
    }
    else m2secho $m2c(info2) $1 *** $3 isn't in ignore list
  }
}
alias m2isignore {
  var %m2.a = $1 $+ .ignores
  var %m2.l = $hget(%m2.a,list)
  if ($istok(%m2.l,$2,32)) {
    var %m2.f = $hget(%m2.a,$2)
    if ($3) return $iif($3 isin %m2.f,$true,$false)
    return $2 %m2.f
  }
  var %m2.j = $numtok(%m2.l,32)
  while (%m2.j) {
    var %m2.c = $gettok(%m2.l,%m2.j,32)
    if (%m2.c iswm $2) {
      var %m2.f = $hget(%m2.a,%m2.c)
      if ($3) return $iif($3 isin %m2.f,$true,$false)
      return %m2.c %m2.f
    }
    dec %m2.j
  }
}
alias m2chl {
  .enable #mirc2list
  .disable #mirc2list.complete
  var %m2.chl = $m2.win(Channels,$1)
  if ($window(%m2.chl)) return
  hadd $1 %m2.chl %m2.chl $+ 1 %m2.chl $+ 2 %m2.chl $+ 3
  window -alk -t20,30,40 %m2.chl $pcv($m2+(@pos.,%m2.chl),$1) @Channels $pcv($m2+(@font.,%m2.chl),$1)
  window -sh %m2.chl $+ 1 0 0 0 0
  window -sh %m2.chl $+ 2 0 0 0 0
  window -sh %m2.chl $+ 3 0 0 0 0
  titlebar %m2.chl - Listing channels...
}
alias m2chlsort {
  var %m2.wn = $m2.win(Channels,$2)
  clear %m2.wn
  if ($1 == name) filter -ww $m2+(%m2.wn,1) %m2.wn *
  elseif ($1 == user) {
    var %w = $m2+(%m2.wn,2)
    var %l = $line(%w,0)
    while (%l) {
      aline %m2.wn $gettok($line(%w,%l),2-,32)
      dec %l
    }
  }
  else {
    var %w = $m2+(%m2.wn,2), %l = 1
    while ($line(%w,%l)) {
      aline %m2.wn $gettok($line(%w,%l),2-,32)
      inc %l
    }
  }
}
alias m2font {
  if (($2 == all) || ($2 == chan)) psv @font.channels $1 $4- $3
  if (($2 == all) || ($2 == query)) psv @font.queries $1 $4- $3
  if (($2 == all) || ($2 == status)) psv @font.status $1 $4- $3
  if (($2 == all) || ($2 == chat)) psv @font.chat $1 $4- $3
  var %m2i = $m2.snum($1), %m2ii = $m2.win(*,$1), %m2iii = 1
  while ($window(%m2ii,%m2iii)) {
    var %m2w = $ifmatch
    if ($ism2win(%m2w)) {
      if (($2 == chan) && ((@#* iswm %m2w) || (@&* iswm %m2w))) font %m2w $3-
      elseif (($2 == status) && (@Status* iswm %m2w)) font %m2w $3-
      elseif ($2 != chat) font %m2w $3-
    }
    inc %m2iii
  }
  if (($2 != all) && ($2 != chat)) return
  var %m2y = 1
  while ($window(@Chat*:*,%m2y)) {
    var %m2w = $ifmatch
    if ($sock($gettok(%m2w,2,58))) {
      var %p = $ifmatch
      if (($m2snm(%p,1-2) == mIRC2 CHAT) && ($m2snm(%p,7) == $1) && ($m2snm(%p,6) == %m2w)) font %m2w $3-
    }
    inc %m2y
  }
}
; EOF
